#!/usr/bin/perl -w

my %defs;

while(<>)
{
  if(/^\s*([\w\d_]+)\s*define\s*([\w\d_]+)\s*(\;.+)?$/i)
    {
      $defs{$1}=$2;
      print "\n";
    }
  else
    {
      my $line=$_;
      foreach(keys %defs)
	{
	  $line =~ s/\b$_\b/$defs{$_}/g;
	}
      print $line;
    }
}
